/*
 * Outputs a string of the given structure.
 *
 * gs <number of parts k> <part1_repeat_count> <part1_period> <part2_repeat_count> <part2_period> ... <partk_repeat_count> <partk_period>
 *
 * Examples:
 *     gs 1 4 ab => abababab 
 *     gs 2 5 a 1 b => aaaaab
 *     gs 3 1 a 5 b 1 a => abbbbba
 */

#include "testlib.h"
#include <iostream>
#include <set>

using namespace std;

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    int n = opt<int>(1);
    int notav = opt<int>(2);
    vector<char> xd; for(char c = 'a'; c <= 'z'; c++) xd.push_back(c);
    for(int i = 0; i < notav; i++){
        int x = rnd.next(0, (int)(xd.size()) - 1);
        xd.erase(xd.begin() + x);
    }

    string t(n, 'a');
    for(int i = 0; i < n; i++)
        t[i] = rnd.any(xd);
    int ares = opt<int>(3);
    int x = rnd.next(0, n - 1);
    int stletter = rnd.next(0, 26 - ares);
    for(int i = x; i < x + ares; i++) t[i % n] = 'a' + stletter + (i-x);
    println(n);
    println(t);
}