

#include "testlib.h"

#include <iostream>
#include <cmath>
#include <algorithm>
#include <stdio.h>
#include <cstring>
#include <string>
#include <cstdlib>
#include <vector>
#include <bitset>
#include <map>
#include <chrono>
#include <functional>
#include <unordered_set>
#include <unordered_map>
#include <numeric>
#include <queue>
#include <ctime>
#include <stack>
#include <set>
#include <list>
#include <deque>
#include <iomanip>
#include <sstream>
#include <fstream>
#include <stdarg.h>
#include <utility>

#define rng(x) for(int _ = 0; _ < (x); _++)
#define rngi(i, x) for(int i = 0; i < (x); i++)
#define rngsi(s, i, x) for(int i = (s); i <(x); i++)
#define vi vector<int>


using namespace std;

const int mxn = 50'000;
const int mxl = 20;

vi g[mxn];
int a[mxn];
int tin[mxn], tou[mxn];
int par[mxn];
int tt = 0;

void dfs(int v, int p = 0) {
    par[v] = p;
    tin[v] = tt++;
    for (int to : g[v])  if (to != p) dfs(to, v);
    tou[v] = tt++;
}
vi cur;
void dfs2(int v) {
    cur.push_back(a[v]);
    for (int to : g[v]) if (to != par[v]) dfs2(to);
}

struct node {
    int basis[mxl];
    int ss;
    void add(int mask) {
        for (int i = mxl - 1; i >= 0; i--) {
            if ((mask & 1 << i) == 0) continue;
            if (!basis[i]) {
                basis[i] = mask;
                ss++;
                return;
            }
            mask ^= basis[i];
        }
    }
    int get(int k) {
        int mask = 0;
        int tot = 1 << ss;
        for (int i = mxl - 1; i >= 0; i--) {
            if (basis[i]) {
                int low = tot / 2;
                if (low < k && (mask & 1 << i) == 0 || (low >= k && (mask & 1 << i) > 0))
                    mask ^= basis[i];
                if (low < k) k -= low;
                tot /= 2;
            }
        }
        return mask;
    }
    node() { ss = 0; memset(basis, 0, sizeof(basis)); }
};
node mrg(const node& l, const node& r) {
    node res;
    memcpy(res.basis, l.basis, sizeof(l.basis));
    res.ss = l.ss;
    rngi(i, mxl) res.add(r.basis[i]);
    return res;
}
node tree[8 * mxn];
void ch(int v, int l, int r, int pos, int nv) {
    if (l == r) {
        tree[v] = node();
        tree[v].add(nv);
        return;
    }
    int m = l + r >> 1;
    if (pos <= m) ch(v << 1, l, m, pos, nv);
    else ch(v << 1 | 1, m + 1, r, pos, nv);
    tree[v] = mrg(tree[v << 1], tree[v << 1 | 1]);
}
node get(int v, int l, int r, int _l, int _r) {
    if (r < _l || _r < l)return node();
    if (_l <= l && r <= _r)return tree[v];
    int m = l + r >> 1;
    return mrg(get(v << 1, l, m, _l, _r), get(v << 1 | 1, m + 1, r, _l, _r));
}
int gr_num;
int chance_bit[mxl];
int gen_number() {
    if(gr_num == 6) return 1 << rnd.next(0, 19);
    int ret = (1 << mxl) - 1;
    rngi(i, mxl)
        if (rnd.next(max(1, 1 << chance_bit[i])) == 0)
            ret ^= 1 << i;
    return ret;
}

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    int n = opt<int>(1);
    int q1 = opt<int>(2);
    int q2 = opt<int>(3);
    int q = q1 + q2;

    int mxa = opt<int>(4);
    int t = opt<int>(5);

    rngi(i, mxl)
        chance_bit[i] = opt<int>(6 + i);
    gr_num = opt<int>(6 + mxl);

    vector<int> p(n);

    for (int i = 0; i < n; i++)
        if (i > 0)
            p[i] = rnd.wnext(i, t);

    cout << n << ' ' << gr_num << '\n';

    vector<int> perm(n);
    for (int i = 0; i < n; i++)
        perm[i] = i;
    shuffle(perm.begin() + 1, perm.end());

    vector<pair<int, int> > edges;
    for (int i = 1; i < n; i++)
        if (rnd.next(2))
            edges.push_back(make_pair(perm[i], perm[p[i]]));
        else
            edges.push_back(make_pair(perm[p[i]], perm[i]));

    shuffle(edges.begin(), edges.end());

    for (int i = 0; i + 1 < n; i++) {
        int u = edges[i].first;
        int v = edges[i].second;
        cout << u + 1 << ' ' << v + 1 << '\n';
        g[u].push_back(v); g[v].push_back(u);
    }

    dfs(0);

    for (int i = 0; i < n; i++) a[i] = gen_number();
    rngi(i, n) cout << a[i] << " \n"[i == n - 1];
    rngi(i, n) ch(1, 0, 2 * n - 1, tin[i], a[i]);

    cout << q << '\n';
    for (int i = 0; i < q; i++) {
        int tp;
        if (q1 == 0) tp = 0;
        else if (q2 == 0) tp = 1;
        else tp = rnd.next(0, 1);

        if (tp) {
            q1--;
            cout << "1 ";
            int x = rnd.next(1, n);
            cout << x << ' ';
            int y = gen_number();
            cout << y << '\n';
            a[x - 1] = y;
            ch(1, 0, 2 * n - 1, tin[x - 1], a[x - 1]);
        }
        else {
            q2--;
            int x = rnd.next(1, n);
            if(rnd.next(1, 5) == 2) x = 1;
            if(gr_num == 4) x = 1;
            cout << "2 " << x;
            auto gg = get(1, 0, 2 * n - 1, tin[x - 1], tou[x - 1]);
            int sz = max(1, (1 << gg.ss) + (1 << (gg.ss - 1)));
            cout << ' ' << rnd.next(1, sz) << '\n';
        }
    }
}